diff -x '*.po' -d -urpN abrt.5/src/Gui/ccgui.glade abrt.6/src/Gui/ccgui.glade
--- abrt.5/src/Gui/ccgui.glade	2009-12-08 15:31:39.249550436 +0100
+++ abrt.6/src/Gui/ccgui.glade	2009-12-08 18:40:59.818025649 +0100
@@ -26,14 +26,25 @@
           </packing>
         </child>
         <child>
-          <widget class="GtkButton" id="bClose">
-            <property name="label" translatable="yes">gtk-close</property>
+          <widget class="GtkHBox" id="hbox1">
             <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="receives_default">True</property>
-            <property name="use_stock">True</property>
-            <property name="xalign">1</property>
-            <property name="yalign">1</property>
+            <child>
+              <widget class="GtkButton" id="bCloseLogWnd">
+                <property name="label" translatable="yes">gtk-close</property>
+                <property name="visible">True</property>
+                <property name="can_focus">True</property>
+                <property name="receives_default">True</property>
+                <property name="use_stock">True</property>
+                <property name="xalign">1</property>
+                <property name="yalign">1</property>
+              </widget>
+              <packing>
+                <property name="expand">False</property>
+                <property name="fill">False</property>
+                <property name="pack_type">end</property>
+                <property name="position">0</property>
+              </packing>
+            </child>
           </widget>
           <packing>
             <property name="expand">False</property>
diff -x '*.po' -d -urpN abrt.5/src/Gui/CCMainWindow.py abrt.6/src/Gui/CCMainWindow.py
--- abrt.5/src/Gui/CCMainWindow.py	2009-12-08 16:02:27.544270364 +0100
+++ abrt.6/src/Gui/CCMainWindow.py	2009-12-08 18:40:59.819024811 +0100
@@ -44,7 +44,7 @@ class MainWindow():
 
         #Get the Main Window, and connect the "destroy" event
         self.window = self.wTree.get_widget("main_window3")
-        if (self.window):
+        if self.window:
             self.window.set_default_size(700, 480)
             self.window.connect("delete_event", self.delete_event_cb)
             self.window.connect("destroy", self.destroy)
@@ -53,7 +53,9 @@ class MainWindow():
         # pregress bar window to show while bt is being extracted
         self.pBarWindow = self.wTree.get_widget("pBarWindow")
         if self.pBarWindow:
-            self.pBarWindow.connect("delete_event", self.sw_delete_event_cb)
+            b = self.wTree.get_widget("bCloseLogWnd")
+            b.connect("clicked", self.pBarWindow_delete_event_cb)
+            self.pBarWindow.connect("delete_event", self.pBarWindow_delete_event_cb)
             self.pBarWindow.set_transient_for(self.window)
 
         #init the dumps treeview
@@ -106,7 +108,6 @@ class MainWindow():
         self.ccdaemon.connect("crash", self.on_data_changed_cb, None)
         self.ccdaemon.connect("analyze-complete", self.on_analyze_complete_cb, self.pBarWindow)
         self.ccdaemon.connect("abrt-error", self.error_cb)
-        #self.ccdaemon.connect("warning", self.warning_cb)
         self.ccdaemon.connect("update", self.update_cb)
         self.ccdaemon.connect("show", self.show_cb)
         self.ccdaemon.connect("daemon-state-changed", self.on_daemon_state_changed_cb)
@@ -149,16 +150,6 @@ class MainWindow():
             return
         dialog.show()
 
-    def warning_cb(self, daemon, message=None):
-        # try to hide the progressbar, we dont really care if it was visible ..
-        try:
-            #gobject.source_remove(self.timer)
-            #self.pBarWindow.hide()
-            pass
-        except Exception, e:
-            pass
-        gui_error_message("%s" % message, parent_dialog=self.window)
-
     def error_cb(self, daemon, message=None):
         # try to hide the progressbar, we dont really care if it was visible ..
         try:
@@ -331,8 +322,9 @@ class MainWindow():
             gui_error_message(_("Error getting the report: %s" % e))
         return
 
-    def sw_delete_event_cb(self, widget, event, data=None):
-        widget.hide()
+    def pBarWindow_delete_event_cb(self, widget, event=None, data=None):
+        # widget.hide() - [Close] hides... [Close] _button_, not the window!
+        self.pBarWindow.hide()
         return True
 
     def delete_event_cb(self, widget, event, data=None):
@@ -359,4 +351,3 @@ if __name__ == "__main__":
     cc.hydrate()
     cc.show()
     gtk.main()
-
diff -x '*.po' -d -urpN abrt.5/src/Gui/CCReporterDialog.py abrt.6/src/Gui/CCReporterDialog.py
--- abrt.5/src/Gui/CCReporterDialog.py	2009-12-08 16:02:27.544270364 +0100
+++ abrt.6/src/Gui/CCReporterDialog.py	2009-12-08 18:40:59.820024952 +0100
@@ -95,7 +95,7 @@ class ReporterDialog():
     # this callback is called when user press Cancel or Report button in Report dialog
     def on_response(self, dialog, response_id, daemon):
         # the button has been pressed (probably)
-        print "response_id", response_id
+        #print "response_id", response_id
         if response_id == gtk.RESPONSE_APPLY:
             if not (self.check_settings(daemon) and self.check_report()):
                 dialog.stop_emission("response")
@@ -301,15 +301,16 @@ class ReporterDialog():
         return True
 
     def run(self):
-        # repeat run() if [Log] btn is pressed
         while 1:
             result = self.window.run()
             if result != RD_BUTTON_LOG:
                 self.pBarWindow.hide()
+                self.pBarWindow.set_modal(False)
                 if self.parent:
                     self.pBarWindow.set_transient_for(self.parent)
-                break
+                self.window.destroy()
+                return (result, self.report)
+            # repeat if [Log] btn is pressed
             self.pBarWindow.set_transient_for(self.window)
             self.pBarWindow.show_all()
-        self.window.destroy()
-        return (result, self.report)
+            self.pBarWindow.set_modal(True)